package jalview.gui;

import jalview.jbgui.GConservationIncrementPanel;
import jalview.datamodel.*;
import jalview.schemes.*;
import java.awt.event.*;
import javax.swing.event.*;

public class ConservationIncrementPanel extends GConservationIncrementPanel
{
  AlignViewport av;
  AlignmentPanel ap;

  public ConservationIncrementPanel(AlignViewport av, AlignmentPanel ap)
  {
    this.av = av;
    this.ap = ap;

    slider.addChangeListener( new ChangeListener()
    {
      public void stateChanged(ChangeEvent evt)
      {
        valueField.setText( slider.getValue()+"" );
        valueChanged( slider.getValue() );
      }
    });

    slider.setValue(30);
  }

  public void valueChanged(int i)
  {
    java.util.Vector groups = av.getAlignment().getGroups();


    for (int j = 0; j < groups.size(); j++)
    {
      SequenceGroup sg = ( (SequenceGroup) groups.elementAt(j));
      if (sg.cs instanceof ConservationColourScheme)
        ( (ConservationColourScheme) sg.cs).inc = i;
    }



     if (av.getGlobalColourScheme() instanceof ConservationColourScheme)
          ( (ConservationColourScheme) av.getGlobalColourScheme()).inc = i;


    ap.seqPanel.seqCanvas.paintFlag=true;
    ap.seqPanel.repaint();

  }

  public void valueField_actionPerformed(ActionEvent e)
  {
    try{
      int i = Integer.parseInt(valueField.getText());
      slider.setValue(i);
    }
    catch(Exception ex)
    {
      valueField.setText( slider.getValue()+"" );
    }
  }
}
